# Enum Class VulkanMemoryPropertyFlag

java.lang.Object
java.lang.Enum<VulkanMemoryPropertyFlag>
com.io7m.jcoronado.api.VulkanMemoryPropertyFlag

All Implemented Interfaces:
  `VulkanEnumBitmaskType`, `Serializable`, `Comparable<VulkanMemoryPropertyFlag>`, `Constable`

public enum VulkanMemoryPropertyFlag extends Enum<VulkanMemoryPropertyFlag> implements VulkanEnumBitmaskType
The properties of a heap.

See Also:
  - "VkMemoryPropertyFlagBits"

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `VK_MEMORY_PROPERTY_DEVICE_LOCAL_BIT`
  Specifies that memory allocated with this type is the most efficient for device access.
  `VK_MEMORY_PROPERTY_HOST_CACHED_BIT`
  Specifies that memory allocated with this type is cached on the host.
  `VK_MEMORY_PROPERTY_HOST_COHERENT_BIT`
  Specifies that the host cache management commands vkFlushMappedMemoryRanges and vkInvalidateMappedMemoryRanges are not needed to flush host writes to the device or make device writes visible to the host, respectively.
  `VK_MEMORY_PROPERTY_HOST_VISIBLE_BIT`
  Specifies that memory allocated with this type can be mapped for host access.
  `VK_MEMORY_PROPERTY_LAZILY_ALLOCATED_BIT`
  Specifies that the memory type only allows device access to the memory and is lazily allocated.
  `VK_MEMORY_PROPERTY_PROTECTED_BIT`
  Specifies that the memory type only allows device access to the memory, and allows protected queue operations to access the memory.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `value()`
  `static VulkanMemoryPropertyFlag`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static VulkanMemoryPropertyFlag[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### VK_MEMORY_PROPERTY_DEVICE_LOCAL_BIT

    public static final VulkanMemoryPropertyFlag VK_MEMORY_PROPERTY_DEVICE_LOCAL_BIT
    Specifies that memory allocated with this type is the most efficient for device access.

  - ### VK_MEMORY_PROPERTY_HOST_VISIBLE_BIT

    public static final VulkanMemoryPropertyFlag VK_MEMORY_PROPERTY_HOST_VISIBLE_BIT
    Specifies that memory allocated with this type can be mapped for host access.

  - ### VK_MEMORY_PROPERTY_HOST_COHERENT_BIT

    public static final VulkanMemoryPropertyFlag VK_MEMORY_PROPERTY_HOST_COHERENT_BIT
    Specifies that the host cache management commands vkFlushMappedMemoryRanges and vkInvalidateMappedMemoryRanges are not needed to flush host writes to the device or make device writes visible to the host, respectively.

  - ### VK_MEMORY_PROPERTY_HOST_CACHED_BIT

    public static final VulkanMemoryPropertyFlag VK_MEMORY_PROPERTY_HOST_CACHED_BIT
    Specifies that memory allocated with this type is cached on the host. Host memory accesses to uncached memory are slower than to cached memory, however uncached memory is always host coherent.

  - ### VK_MEMORY_PROPERTY_LAZILY_ALLOCATED_BIT

    public static final VulkanMemoryPropertyFlag VK_MEMORY_PROPERTY_LAZILY_ALLOCATED_BIT
    Specifies that the memory type only allows device access to the memory and is lazily allocated.

  - ### VK_MEMORY_PROPERTY_PROTECTED_BIT

    public static final VulkanMemoryPropertyFlag VK_MEMORY_PROPERTY_PROTECTED_BIT
    Specifies that the memory type only allows device access to the memory, and allows protected queue operations to access the memory.

- ## Method Details

  - ### values

    public static VulkanMemoryPropertyFlag[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static VulkanMemoryPropertyFlag valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### value

    public int value()
    Specified by:
      `value` in interface `VulkanEnumBitmaskType`
    Returns:
      The integer value of the constant